Package: org.codehaus.groovy.vmplugin.v8

## [Java] Class IndyGuardsFiltersAndSignatures

- org.codehaus.groovy.vmplugin.v8.IndyGuardsFiltersAndSignatures

-     public class IndyGuardsFiltersAndSignatures
      extends Object

  This class contains guards, runtime filters and MethodType signatures used by indy.

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `protected static MethodHandle` | `NULL_REF` |
    `protected static MethodHandle` | `SAME_CLASS` |

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `public static Object` | `invokeGroovyObjectInvoker(MissingMethodException e, Object receiver, String name, Object[] args)` GroovyObject.invokeMethod path as fallback.
    `` | `public static boolean` | `isNull(Object o)` Guard to check if the argument is null.
    `` | `public static boolean` | `isSameMetaClass(MetaClass mc, Object receiver)` called by handle
    `` | `public static boolean` | `sameClass(Class<?> c, Object o)` Guard to check if the provided Object has the same class as the provided Class.
    `` | `public static boolean` | `sameClasses(Object[] cs, Object[] os)` Guard to check if the provided objects have the same class as the other provided objects.
    `` | `public static Object` | `setBeanProperties(MetaClass mc, Object bean, Map properties)` This method is called by the handle to realize the bean constructor with property map.
    `` | `public static Object` | `unwrap(GroovyRuntimeException gre)` Unwraps a GroovyRuntimeException.
    `` | `public static Object` | `unwrap(Object o)` Unwraps a Wrapper.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Field Detail

    - #### protected static final MethodHandle NULL_REF

    - #### protected static final MethodHandle SAME_CLASS

  - ### Method Detail

    - #### public static Object invokeGroovyObjectInvoker(MissingMethodException e, Object receiver, String name, Object[] args)

      GroovyObject.invokeMethod path as fallback. This method is called by the handle as exception handler in case the selected method causes a MissingMethodExecutionFailed, where we will just give through the exception, and a normal MissingMethodException where we call GroovyObject.invokeMethod if receiver class, the type transported by the exception and the name for the method stored in the exception and our current method name are equal. Should those conditions not apply we just rethrow the exception.

    - #### public static boolean isNull(Object o)

      Guard to check if the argument is null. This method is called by the handle to check if the provided argument is null.

    - #### public static boolean isSameMetaClass(MetaClass mc, Object receiver)

      called by handle

    - #### public static boolean sameClass(Class<?> c, Object o)

      Guard to check if the provided Object has the same class as the provided Class. This method will return false if the Object is null.

    - #### public static boolean sameClasses(Object[] cs, Object[] os)

      Guard to check if the provided objects have the same class as the other provided objects.

    - #### public static Object setBeanProperties(MetaClass mc, Object bean, Map properties)

      This method is called by the handle to realize the bean constructor with property map.

    - #### public static Object unwrap(GroovyRuntimeException gre)

      Unwraps a GroovyRuntimeException. This method is called by the handle to unwrap internal exceptions of the runtime.

    - #### public static Object unwrap(Object o)

      Unwraps a Wrapper. This method is called by the handle to unwrap a Wrapper, which we use to force method selection.